#ifndef NBODY_H_
#define NBODY_H_

#define ACCEL_THRESHOLD	1.0

typedef struct point{
	float x;
	float y;
	float vx;
	float vy;
	float m;
} point_t;

typedef struct state{
	int nplots;
	float msum;
	int xmax;
	int ymax;
	int xmin;
	int ymin;
	float gc;
	int delta_t;
	int cutoff;
} state_t;

typedef struct field{
	int nplots;
	int msum;
} field_t;

int init_plots_map(char* filename, state_t *st, point_t **plots);
void make_plots_map(point_t **plots, state_t *st, int nplots, point_t max, point_t min, int cutoff, int delta_t);
void write_plots_map(char* filename, state_t *st, point_t *plots);
void print_plos_map(point_t *plots, state_t st, int px, int py);
void dump_plots_map(point_t *plots, state_t st);
int fini_plots_map(point_t *plots);

#endif /*NBODY_H_*/
