#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "nbody.h"

typedef struct vector{
	float x;
	float y;
} vector_t;

static void calc_acceleration(point_t* i, point_t* j, vector_t* accel, state_t* st);
static void do_step(point_t* plots, state_t *st, vector_t* accel);
int main(int argc, char** argv){
	point_t *plots;
	vector_t *accel;
	state_t st;
	int i;
	int nstep;
	
	// t@Cǂݍ
	init_plots_map(argv[1], &st, &plots);
	// xf[^ۑp̗̈m
	if((accel = (vector_t*) malloc(sizeof(vector_t) * st.nplots)) == NULL){
		perror("malloc");
	}
	
	nstep = atoi(argv[3]);
	for(i = 0; i < nstep; i++){
		do_step(plots, &st, accel);		
	}
	
	write_plots_map(argv[2], &st, plots);
	fini_plots_map(plots);
	free(accel);
	return 1;
}


static void calc_acceleration(point_t* i, point_t* j, vector_t* accel, state_t* st){
	vector_t direction;
	vector_t delta;
	float norm_squr;
	
	//xvZ
	// m * a_vector = GmM / r_norm^2 * r_vector

	// _ԋ
	delta.x = i->x - j->x;
	delta.y = i->y - j->y;
	norm_squr = delta.x * delta.x + delta.y * delta.y;
	// ͂̋yԕ
	direction.x = delta.x / sqrt(norm_squr);
	direction.y = delta.y / sqrt(norm_squr);
	// xZo
	accel->x = (st->gc * j->m / norm_squr) * direction.x;
	accel->y = (st->gc * j->m / norm_squr) * direction.y;

}

static void do_step(point_t* plots, state_t* st, vector_t* accel)
{
	int i, j;
	vector_t accel_work;
	
	//xvZ
	for(i = 0; i < st->nplots; i++){
		accel[i].x = 0.0;
		accel[i].y = 0.0;
		for(j = 0; j < st->nplots; j++){
			if(i == j) continue;
			calc_acceleration(&(plots[i]), &(plots[j]), &accel_work, st);
			accel[i].x += accel_work.x;
			accel[i].y += accel_work.y;
		}
	}
	//ʒuExvZ
	for(i = 0; i < st->nplots; i++){
		plots[i].x += plots[i].vx * st->delta_t;
		plots[i].y += plots[i].vy * st->delta_t;
		plots[i].vx += accel[i].x * st->delta_t;
		plots[i].vy += accel[i].y * st->delta_t;
	}
}
